#include <stdio.h>
#include "romanize.h"
#include "irc.h"

char *hcode(char *instr)
{
  unsigned char in;
  unsigned long int PrintChar=0;
  static char outstr[1000];
  char *tmpoutstr = outstr;
  int i = strlen(instr);

  *(instr+i) = ' ';
  *(instr+i+1) = '\0';

  while (in = (unsigned char) *instr++) {
    PrintChar = (*getks)(in);
    if ( PrintChar != 0 ) 
      tmpoutstr = pr3b(PrintChar, (char *)tmpoutstr);
    PrintChar = 0;
  }


/*  in = (unsigned char)' ';
  PrintChar = (*getks)(in);
if ( PrintChar != 0 )
      tmpoutstr = pr3b(PrintChar, (char *)tmpoutstr);
    PrintChar = 0;
*/

  *--tmpoutstr = '\0';
  return( outstr);
  
}


/* ***********************************************************
                KS5601, Han3 Code Input Section
*********************************************************** */
unsigned long int getks(unsigned char c)
{
  static unsigned long int first=0, all=0, a4=0;
  unsigned long int tmp;
  
  if ( c<0x80 ) {                         /* ASC */
    first = 0;
    return c;
  }
  
  if ( first == 0 ) {                     /* First MSB Char */
    first = c;
    return 0;
  } else if ( first == 0xa4 ) {
    if ( c == 0xd4 ) {              /* KSC FILL */
      first = 0xd4;
      return 0;
    } else {                        /* Separate Jamo */
      first = 0;
      return (0x8ffba4<<8) + c;
    }
  } else if ( first==0x8f || first==0xd4 ) {      /* han3 or KS-8 */
    if ( first==0x8f || a4==1 ) {
      all = (all<<8) + c;
      a4 = 0;
    } else if ( c == 0xa4 ) {
      a4 = 1;
    }
    if ( all <= 0xffff ) {
      return 0;
    } else {
      tmp = (first<<24) + all;
      all = 0;
      first = 0;
      return tmp;
    }
  } else {                                /* Usual 2byte KSC */
    tmp = (0x8ffb<<16) + (first<<8) + c;
    first = 0;
    return tmp;
  }
}


#include "h3Bcode.h"
#include "h2Bcode.h"

char *pr3b(unsigned long int wc, char *outstr)
{
  static int C;
  int ch,ju,jo;
  static unsigned char StartC=(unsigned char)NULL, EndC=(unsigned char)NULL;
  char tmpstr[4], *tmpptr;
  
  tmpptr = tmpstr;

  if ( prstat == PRNONE ) {
    C=2;
    StartC = StartCode[C];
    EndC = EndCode[C];
    prstat = PRENG;
  }
  
  if ( wc>>8 == 0 ) {
    if (prstat == PRINTING && EndC != (unsigned char)NULL)
      *outstr++ = (char)EndC;
    
    if (prstat == PRINTING) prstat = PRINTED;
/*    if ( wc == StartC ) 
      outstr++ = wc; */
    *outstr++ = (char)wc;
    return (outstr);
  }
  
  wc = convtr(wc);
  
  ch = ( wc >> 10 ) & 0x1f;
  ju = ( wc >>  5 ) & 0x1f;
  jo = ( wc       ) & 0x1f;
  if ( ch==01 || ju==02 ) {
    if (prstat == PRINTING) {
      *outstr++ = (char)EndC;
      *outstr++ = (char)StartC;
    }
    else if ( prstat == PRINTED || prstat == PRENG )
      *outstr++ = (char)StartC;
    if ( ju==2 && jo!=1 )           /* Nbyte Final Only */
      {
	strcpy(tmpstr, Jamo[C][0][ch]);
	while (*outstr++ = *tmpptr++)
	  ;
	outstr--;

	tmpptr = tmpstr;
	strcpy(tmpstr, NbFinalOnly[C]);
	while (*outstr++ = *tmpptr++)
	  ;
	outstr--;

	tmpptr = tmpstr;
	strcpy(tmpstr, Jamo[C][2][jo]);
	while (*outstr++ = *tmpptr++)
	  ;
	outstr--;

	*outstr++ = (char)EndC;
      }

    else
      {

	tmpptr = tmpstr;
	strcpy(tmpstr, Jamo[C][0][ch]);
	while (*outstr++ = *tmpptr++)
	  ;
	outstr--;

	tmpptr = tmpstr;	
	strcpy(tmpstr, Jamo[C][1][ju]);
	while (*outstr++ = *tmpptr++)
	  ;
	outstr--;

	tmpptr = tmpstr;
	strcpy(tmpstr, Jamo[C][2][jo]);
	while (*outstr++ = *tmpptr++)
	  ;
	outstr--;

	*outstr++ = (char)EndC;
      }
    prstat = PRINTED;
  } else {
    if (prstat == PRINTING)
      *outstr++ = '-';

    else if ( prstat == PRINTED || prstat == PRENG )
      *outstr++ = (char)StartC;

	tmpptr = tmpstr;
	strcpy(tmpstr, Jamo[C][0][ch]);
	while (*outstr++ = *tmpptr++)
	  ;
	outstr--;

	tmpptr = tmpstr;
	strcpy(tmpstr, Jamo[C][1][ju]);
	while (*outstr++ = *tmpptr++)
	  ;
	outstr--;

	tmpptr = tmpstr;
	strcpy(tmpstr, Jamo[C][2][jo]);
	while (*outstr++ = *tmpptr++)
	  ;
	outstr--;

    prstat = PRINTING;
  }
  return (outstr);
}





unsigned long int convtr(unsigned long int wc)
{
  unsigned int test;
  int l,m,u;
  
  l = NoUnSorted;
  u = NoKSC-1;
  wc = wc & 0xffff;
  
  while ( l<=u ) {
    test = TwoConvert[(m=(l+u)/2)][1];
    if ( test > wc ) u=m-1;
    else if ( test < wc ) l=m+1;
    else {
      return(TwoConvert[m][0]);
    }
  }
  
  for (m=0; m<NoUnSorted; m++) 
    if ( TwoConvert[m][1] == wc ) {
      return(TwoConvert[m][0]);
    }
  return (0xff000000+TwoConvert[m][0]);
}







